do
    -- flags: 
    -- 1 blue score
    -- 2 red score
    -- 3 increase aaa spawn interval
    -- 4 decrease aaa spawn interval
    -- 5 increase ai cas spawn interval
    -- 6 decrease ai cas spawn interval
    -- 7 increase ai cap spawn interval
    -- 8 decrease ai cap spawn interval
    -- 9 set default spawn intervals
    -- 10 display status
    -- 11 aaa spawn intveral in minutes
    -- 12 ai cas spawn interval in minutes
    -- 13 ai cap spawn interval in minutes
  
    -- armor spawns: 3 mins, no change
    -- aaa spawns: 15 min 15 sec, +- 3 mins, min 1 mins, max 100 mins
    -- cas spawns: 12 min 20 sec, +- 3 mins
    -- cap spawns: 30 min 10 sec, +- 3 mins
    
    local function checkCommand(command_flag,value_flag,difference)
        if trigger.misc.getUserFlag(command_flag) == 1 then
            local val=trigger.misc.getUserFlag(value_flag)+difference
            if val>100 then
                val=100
            end
            if val<1 then
                val=1
            end
            trigger.action.setUserFlag(value_flag,val)
            trigger.action.setUserFlag(command_flag,0)
        end
    end
    
    --env.info("command check script start")
    
    checkCommand(3,11,3)
    checkCommand(4,11,-3)
    checkCommand(5,12,3)
    checkCommand(6,12,-3)
    checkCommand(7,13,3)
    checkCommand(8,13,-3)
    
    if trigger.misc.getUserFlag(9) == 1 then
        trigger.action.setUserFlag(11,15)
        trigger.action.setUserFlag(12,12)
        trigger.action.setUserFlag(13,30)
        trigger.action.setUserFlag(9,0)
    end
    
    if trigger.misc.getUserFlag(10) == 1 then
        trigger.action.setUserFlag(10,0)
    end
    
    trigger.action.outText(string.format("Mission score: Blue: %d Red: %d\nArmor spawn interval: 3 mins\nAAA spawn interval: %d mins\nAI CAS spawn interval: %d mins\nAI CAP spawn interval: %d mins",trigger.misc.getUserFlag(1),trigger.misc.getUserFlag(2),trigger.misc.getUserFlag(11),trigger.misc.getUserFlag(12),trigger.misc.getUserFlag(13)),10)
	--env.info("command check script finish")
end
