do
    local wps={
    {
        {["x"]=-292774,["y"]=861117.71428574,["alt"] = 510}, --blue spawn, red endpoint
    },
    { --level 1 points for blue, level 4 points for red
        {["x"]=-294524,["y"]=863497.71428574,["alt"] = 572},
        {["x"]=-292866.85714286,["y"]=863412.00000002,["alt"] = 542},
        {["x"]=-291324,["y"]=863354.85714288,["alt"] = 554}
    },
    { --level 2 points for blue, level 3 points for red
        {["x"]=-291166.85714286,["y"]=865426.28571431,["alt"] = 601},
        {["x"]=-292630.85714285,["y"]=865475.14285716,["alt"] = 593},
        {["x"]=-294295.42857143,["y"]=865554.85714288,["alt"] = 591}
    },
    {
        {["x"]=-294166.85714286,["y"]=867412.00000002,["alt"] = 621},
        {["x"]=-292466.85714286,["y"]=867297.71428574,["alt"] = 613},
        {["x"]=-291024,["y"]=867140.57142859,["alt"] = 629}
    },
    {
        {["x"]=-290838.28571429,["y"]=868983.42857145,["alt"] = 605},
        {["x"]=-292345.14285714,["y"]=869118.00000002,["alt"] = 601},
        {["x"]=-293881.14285715,["y"]=869240.57142859,["alt"] = 598}
    },
    {
        {["x"]=-292469.42857142,["y"]=871443.71428573,["alt"] = 536} --blue endpoint, red spaw,
    }
    }
    local blue_aa_pos={
        {["x"]=-293493.42857143,["y"]=861618.85714285,["alt"] = 499}, --candidates for blue aa init pos
        {["x"]=-292873.42857143,["y"]=861098.85714285,["alt"] = 508},
        {["x"]=-292053.42857143,["y"]=861596,["alt"] = 529}
    }
    local red_aa_pos={
        {["x"]=-293403.42857143,["y"]=871333.14285714,["alt"] = 578}, --candidates for red aa init pos
        {["x"]=-292532,["y"]=871818.85714286,["alt"] = 517},
        {["x"]=-291782,["y"]=870990.28571429,["alt"] = 539}
    }

    local blue_init_pos={
        {["x"]=-292774,["y"]=861117.71428574},
        {["x"]=-292806.57142857,["y"]=861119.71428574},
        {["x"]=-292840.85714286,["y"]=861120.28571431},
        {["x"]=-292871.14285715,["y"]=861120.28571431}
        --{["x"]=-292902.57142857,["y"]=861120.28571431},
        --{["x"]=-292938,["y"]=861120.28571431}
    }
    local red_init_pos={
        {["x"]=-292406.85714284,["y"]=871535.14285716},
        {["x"]=-292434.85714284,["y"]=871536.85714287},
        {["x"]=-292464.57142855,["y"]=871539.14285716},
        {["x"]=-292489.14285712,["y"]=871540.85714287}
        --{["x"]=-292518.28571427,["y"]=871540.85714287},
        --{["x"]=-292551.99999998,["y"]=871542.00000002}
    }
    local function getGroupTemplate()
        local group_template={
            ["visible"] = false,
            ["taskSelected"] = true,
            ["route"] =
            {
            },
            ["tasks"] =
            {
            },
            ["hidden"] = false,
            ["units"] =
            { --add units
            },
            ["y"] = 861117.71428574, --change x,y
            ["x"] = -292774,
            ["name"] = "blue_group_1", --change name
            ["start_time"] = 0,
            ["task"] = "Ground Nothing"
        }
        return group_template
    end

    local function getUnitTemplate()
        local unit_template={
            --["type"] = "T-72B", -- for aa: ZSU-23-4 Shilka
            --["type"] = "LAV-25", -- for aa: ZSU-23-4 Shilka
            ["type"] = "T-55",
            ["name"] = "Unit #001", --change name
            ["heading"] = -1.6140286482639, --change heading for blue
            ["playerCanDrive"] = true,
            ["skill"] = "High",
            ["x"] = -292938, --change x,y
            ["y"] = 861120.28571431
        }
        return unit_template
    end
    local function getWaypointTemplate()
        local waypoint_template={
            ["type"] = "Turning Point",
            ["ETA_locked"] = false,
            ["speed"] = 7.5555555555556,
            ["action"] = "Rank",
            ["task"] =
            {
                ["id"] = "ComboTask",
                ["params"] =
                {
                    ["tasks"] =
                    {
                    },
                },
            },
            ["speed_locked"] = true,
            ["y"] = 871443.71428573, --change x,y
            ["x"] = -292469.42857142
        }
        return waypoint_template
    end
  
    local function spawnGroup(isblue)
        local baseid=(math.floor(timer.getTime())+30)*20
        local countryid=country.id.GEORGIA
        local initpos=blue_init_pos
        local nameprefix="blue"
        if not isblue then
            baseid=baseid+10
            countryid=country.id.RUSSIA
            initpos=red_init_pos
            nameprefix="red"
        end
        local tankgroup=getGroupTemplate()
        if isblue then
            tankgroup.x=wps[1].x
            tankgroup.y=wps[1].y
        else
            tankgroup.x=wps[table.getn(wps)].x
            tankgroup.y=wps[table.getn(wps)].y
        end
        tankgroup.name=string.format("%s_group_%d",nameprefix,baseid)
        for k,v in pairs(initpos) do
          tankgroup.units[k]=getUnitTemplate()
          tankgroup.units[k].name=string.format("%s_unit_%d",nameprefix,baseid+k)
          if isblue then
            tankgroup.units[k].heading=tankgroup.units[k].heading*-1
          end
          tankgroup.units[k].x=v.x
          tankgroup.units[k].y=v.y
        end
        coalition.addGroup(countryid, Group.Category.GROUND, tankgroup)
        local routetask={id = 'Mission',params={route={points={}}}}
        for k,v in pairs(wps) do
          local pt=getWaypointTemplate()
          subid=math.random(table.getn(v))
          pt.x=v[subid].x
          pt.y=v[subid].y
          if isblue then
            routetask.params.route.points[k]=pt
          else
            routetask.params.route.points[table.getn(wps)-k+1]=pt
          end
        end
        local tankgroupobj = Group.getByName(tankgroup.name)
        local contr=tankgroupobj:getController()
        if contr then
          contr:setTask(routetask)
        end
	end
    
    local function spawnGroups()
        --env.info("spawn function start")
        spawnGroup(true)
        spawnGroup(false)
        --env.info(dcstad:table_to_string(bluegroup))
        --env.info("spawn function end")
        return timer.getTime() + 180
    end
    
    local function spawnAAGroup(isblue)
        local baseid=(math.floor(timer.getTime())+30)*20
        local countryid=country.id.GEORGIA
        local initpos=blue_init_pos
        local nameprefix="blue"
        if not isblue then
            baseid=baseid+10
            countryid=country.id.RUSSIA
            initpos=red_init_pos
            nameprefix="red"
        end
        local aagroup=getGroupTemplate()
        if isblue then
            subid=math.random(table.getn(blue_aa_pos))
            aagroup.x=blue_aa_pos[subid].x
            aagroup.y=blue_aa_pos[subid].y
        else
            subid=math.random(table.getn(red_aa_pos))
            aagroup.x=red_aa_pos[subid].x
            aagroup.y=red_aa_pos[subid].y
        end
        aagroup.name=string.format("%s_aa_group_%d",nameprefix,baseid)
        aagroup.units[1]=getUnitTemplate()
        aagroup.units[1].type = "ZSU-23-4 Shilka"
        aagroup.units[1].name=string.format("%s_aa_unit_%d",nameprefix,baseid+1)
        if isblue then
            aagroup.units[1].heading=aagroup.units[1].heading*-1
        end
        aagroup.units[1].x=aagroup.x
        aagroup.units[1].y=aagroup.y
        coalition.addGroup(countryid, Group.Category.GROUND, aagroup)
        local routetask={id = 'Mission',params={route={points={}}}}
        for k,v in pairs(wps) do
          local pt=getWaypointTemplate()
          if isblue and k==1 then
            pt.x=aagroup.x
            pt.y=aagroup.y
          elseif (not isblue) and k==table.getn(wps) then
            pt.x=aagroup.x
            pt.y=aagroup.y
          else
            subid=math.random(table.getn(v))
            pt.x=v[subid].x
            pt.y=v[subid].y
          end
          if isblue then
            routetask.params.route.points[k]=pt
          else
            routetask.params.route.points[table.getn(wps)-k+1]=pt
          end
        end
        local aagroupobj = Group.getByName(aagroup.name)
        local contr=aagroupobj:getController()
        if contr then
          contr:setTask(routetask)
        end
	end
    
    local function spawnAAGroups()
        --env.info("spawn aa function start")
        spawnAAGroup(true)
        spawnAAGroup(false)
        --env.info("spawn aa function end")
        return timer.getTime() + trigger.misc.getUserFlag(11)*60+13
    end
    
    local function unitDetectedInBlueBase(unit)
        if unit:getDesc().category==Unit.Category.GROUND_UNIT and unit:getCoalition()==1 then
            unit:getGroup():destroy()
            trigger.action.setUserFlag(2,trigger.misc.getUserFlag(2)+1)
            trigger.action.outText(string.format("Mission score: Blue: %d Red: %d",trigger.misc.getUserFlag(1),trigger.misc.getUserFlag(2)),10)
            env.info("announced score")
            return false
        end
        return true
    end
    
    local function unitDetectedInRedBase(unit)
        if unit:getDesc().category==Unit.Category.GROUND_UNIT and unit:getCoalition()==2 then
            unit:getGroup():destroy()
            trigger.action.setUserFlag(1,trigger.misc.getUserFlag(1)+1)
            trigger.action.outText(string.format("Mission score: Blue: %d Red: %d",trigger.misc.getUserFlag(1),trigger.misc.getUserFlag(2)),10)
            return false
        end
        return true
    end
    
    local zoneradius=500
    local blueBase={
        ["id"]=world.VolumeType.SPHERE,
        ["params"]={
            ["point"]={
                ["x"]=wps[1][1].x,
                ["y"]=wps[1][1].alt,
                ["z"]=wps[1][1].y
            },
            ["radius"]=zoneradius
        }
    }
    local redBase={
        ["id"]=world.VolumeType.SPHERE,
        ["params"]={
            ["point"]={
                ["x"]=wps[table.getn(wps)][1].x,
                ["y"]=wps[table.getn(wps)][1].alt,
                ["z"]=wps[table.getn(wps)][1].y
            },
            ["radius"]=zoneradius
        }
    }
    local function checkReachedGroups()
        --env.info("checkReachedGroups start")
        --env.info(string.format("blue zone: %s",dcstad:table_to_string(blueBase)))
        --env.info(string.format("red zone: %s",dcstad:table_to_string(redBase)))
        world.searchObjects(Object.Category.UNIT,blueBase,unitDetectedInBlueBase)
        world.searchObjects(Object.Category.UNIT,redBase,unitDetectedInRedBase)
        --env.info("checkReachedGroups finish")
        return timer.getTime() + 5
    end
    
    --ground units ends
    ----------------------------------------------
    ----------------------------------------------
    --air units start
    
    local blue_casunit_pos={
        {["x"]=-282214.28571429,["y"]=836685.7142857,["alt"] = 2000}, --candidates for blue air cas unit init pos
        {["x"]=-292157.14285714,["y"]=835028.57142856,["alt"] = 2000},
        {["x"]=-302157.14285714,["y"]=836114.28571428,["alt"] = 2000}
    }
    local red_casunit_pos={
        {["x"]=-289585.71428571,["y"]=899028.57142856,["alt"] = 2000}, --candidates for red air cas unit init pos
        {["x"]=-296042.85714286,["y"]=899028.57142856,["alt"] = 2000},
        {["x"]=-278042.85714286,["y"]=896399.99999999,["alt"] = 2000}
    }
    
    local blue_capunit_pos={
        {["x"]=-299328.57142857,["y"]=810714.28571428,["alt"] = 2000}, --candidates for blue air cap unit init pos
        {["x"]=-267200,["y"]=815971.42857143,["alt"] = 2000},
        {["x"]=-287571.42857143,["y"]=810557.14285714,["alt"] = 2000}
    }
    local red_capunit_pos={
        {["x"]=-282614.28571428,["y"]=921542.85714284,["alt"] = 2000}, --candidates for red air cap unit init pos
        {["x"]=-268500,["y"]=916685.7142857,["alt"] = 2000},
        {["x"]=-292042.85714286,["y"]=921371.42857141,["alt"] = 2000}
    }
    
    local airunit_wps={
        {["x"]=-292623.14285714,["y"]=866610.57142857,["alt"] = 2000}, -- second waypoint for bot blue,red
        {["x"]=-194514.28571429,["y"]=851342.85714286,["alt"] = 2000} -- third waypoint (egress) for both blue, red. if aircraft reaches here, it is removed
    }
    
    local function getAirCASGroupTemplate()
        local air_group_template={
            ["lateActivation"] = false,
            ["tasks"] = 
            {
            },
            ["radioSet"] = false,
            ["task"] = "CAS",
            ["uncontrolled"] = false,
            ["route"] = 
            {
                ["routeRelativeTOT"] = true,
                ["points"] = 
                {
                    [1] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 0,
                        ["y"] = 834742.85714285, --change, init pos
                        ["x"] = -290771.42857144, --change, init pos
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                    [1] = 
                                    {
                                        ["enabled"] = true,
                                        ["key"] = "CAS",
                                        ["id"] = "EngageTargets",
                                        ["number"] = 1,
                                        ["auto"] = true,
                                        ["params"] = 
                                        {
                                            ["targetTypes"] = 
                                            {
                                                [1] = "Helicopters", --?
                                                [2] = "Ground Units",
                                                [3] = "Light armed ships",
                                            },
                                            ["priority"] = 0,
                                        },
                                    },
                                    [2] = 
                                    {
                                        ["enabled"] = true,
                                        ["auto"] = true,
                                        ["id"] = "WrappedAction",
                                        ["number"] = 2,
                                        ["params"] = 
                                        {
                                            ["action"] = 
                                            {
                                                ["id"] = "EPLRS",
                                                ["params"] = 
                                                {
                                                    ["value"] = true,
                                                    ["groupId"] = 10,
                                                },
                                            },
                                        },
                                    },
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [2] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 229.28146858552,
                        ["y"] = 866542.85714285,
                        ["x"] = -292457.14285715,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [3] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 942.52425499081,
                        ["y"] = 851142.85714286,
                        ["x"] = -194600.00000001,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [4] = 
                    {
                        ["alt"] = 430,
                        ["type"] = "Land",
                        ["action"] = "Landing",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 1766.1050695148,
                        ["airdromeId"] = 27,
                        ["y"] = 760428.0733062,
                        ["x"] = -124921.90954665,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                },
            },
            --["groupId"] = 34, -- change
            ["hidden"] = false,
            ["units"] = 
            {
                [1] = 
                {
                    ["alt"] = 2000,
                    ["hardpoint_racks"] = true,
                    ["alt_type"] = "BARO",
                    ["livery_id"] = "104th FS Maryland ANG, Baltimore (MD)", --change for red
                    --["livery_id"] = "Fictional Russian Air Force 1",
                    ["skill"] = "Excellent",
                    ["speed"] = 138.88888888889,
                    ["type"] = "A-10C",
                    --["unitId"] = 34, --change
                    ["psi"] = -1.623756640109,
                    ["y"] = 834742.85714285, --change init pos
                    ["x"] = -290771.42857144, --change init pos
                    ["name"] = "Pilot #026", -- change
                    ["payload"] = 
                    {
                        ["pylons"] = 
                        {
                            [7] = 
                            {
                                ["CLSID"] = "{BCE4E030-38E9-423E-98ED-24BE3DA87C32}",
                            },
                            [8] = 
                            {
                                ["CLSID"] = "{64329ED9-B14C-4c0b-A923-A3C911DA1527}",
                            },
                            [3] = 
                            {
                                ["CLSID"] = "{64329ED9-B14C-4c0b-A923-A3C911DA1527}",
                            },
                            [9] = 
                            {
                                ["CLSID"] = "{64329ED9-B14C-4c0b-A923-A3C911DA1527}",
                            },
                            [4] = 
                            {
                                ["CLSID"] = "{64329ED9-B14C-4c0b-A923-A3C911DA1527}",
                            },
                            [5] = 
                            {
                                ["CLSID"] = "{BCE4E030-38E9-423E-98ED-24BE3DA87C32}",
                            },
                            [10] = 
                            {
                                ["CLSID"] = "{A111396E-D3E8-4b9c-8AC9-2432489304D5}",
                            },
                        },
                        ["fuel"] = 4275,
                        ["flare"] = 120,
                        ["ammo_type"] = 1,
                        ["chaff"] = 240,
                        ["gun"] = 100,
                    },
                    ["heading"] = 1.623756640109, --change
                    --["heading"] = -1.6705058840289,
                    --["callsign"] =  --change?
                    --{
                    --    [1] = 9,
                    --    [2] = 1,
                    --    [3] = 1,
                    --    ["name"] = "Hawg11",
                    --},
                    --["callsign"] = 112,
                    --["onboard_num"] = "054", --?
                },
            },
            ["y"] = 834742.85714285, --change, init pos
            ["x"] = -290771.42857144, --change, init pos
            ["name"] = "blue_ai_cas_1", -- change
            --["communication"] = true,
            --["start_time"] = 0,
            --["modulation"] = 0,
            --["frequency"] = 251,
        }
        return air_group_template
    end
    
    local function spawnAirCASGroups()
        --env.info('spawnAirGroup start')
        local airgroup=getAirCASGroupTemplate()
        local baseid=(math.floor(timer.getTime())+37)*20
        subid=math.random(table.getn(blue_casunit_pos))
        airgroup.route.points[1].y=blue_casunit_pos[subid].y
        airgroup.route.points[1].x=blue_casunit_pos[subid].x
        airgroup.units[1].x=blue_casunit_pos[subid].x
        airgroup.units[1].y=blue_casunit_pos[subid].y
        airgroup.x=blue_casunit_pos[subid].x
        airgroup.y=blue_casunit_pos[subid].y
        airgroup.units[1].name=string.format("blue_ai_cas_unit_%d",baseid)
        airgroup.name=string.format("blue_ai_cas_%d",baseid)
        coalition.addGroup(country.id.USA, Group.Category.AIRPLANE, airgroup)
        airgroup=getAirCASGroupTemplate()
        baseid=baseid+1
        subid=math.random(table.getn(red_casunit_pos))
        airgroup.route.points[1].y=red_casunit_pos[subid].y
        airgroup.route.points[1].x=red_casunit_pos[subid].x
        airgroup.units[1].x=red_casunit_pos[subid].x
        airgroup.units[1].y=red_casunit_pos[subid].y
        airgroup.x=red_casunit_pos[subid].x
        airgroup.y=red_casunit_pos[subid].y
        airgroup.units[1].name=string.format("red_ai_cas_unit_%d",baseid)
        airgroup.name=string.format("red_ai_cas_%d",baseid)
        airgroup.units[1].heading = -1.67050
        airgroup.units[1].livery_id= "Fictional Russian Air Force 1"
        coalition.addGroup(country.id.RUSSIA, Group.Category.AIRPLANE, airgroup)
        --env.info('spawnAirGroup finish')
        return timer.getTime() + trigger.misc.getUserFlag(12)*60+20
	end
    
    local function getBlueAirCAPGroupTemplate()
        local air_group_template={
            ["lateActivation"] = false,
            ["tasks"] = 
            {
            },
            ["radioSet"] = false,
            ["task"] = "CAP",
            ["uncontrolled"] = false,
            ["route"] = 
            {
                ["routeRelativeTOT"] = true,
                ["points"] = 
                {
                    [1] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 0,
                        ["y"] = 810485.71428571, --change
                        ["x"] = -287874.2857143, --change 
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                    [1] = 
                                    {
                                        ["number"] = 1,
                                        ["key"] = "CAP",
                                        ["id"] = "EngageTargets",
                                        ["enabled"] = true,
                                        ["auto"] = true,
                                        ["params"] = 
                                        {
                                            ["targetTypes"] = 
                                            {
                                                [1] = "Air",
                                            },
                                            ["priority"] = 0,
                                        },
                                    }, 
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [2] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 447.27748826528,
                        ["y"] = 866564.28571429,
                        ["x"] = -292524.2857143,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    }, 
                    [3] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 1161.116891032,
                        ["y"] = 851267.14285714,
                        ["x"] = -194567.14285715,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            }, 
                        },
                        ["speed_locked"] = true,
                    },
                    [4] = 
                    {
                        ["alt"] = 430,
                        ["type"] = "Land",
                        ["action"] = "Landing",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 1985.2635969858,
                        ["airdromeId"] = 27,
                        ["y"] = 760428.0733062,
                        ["x"] = -124921.90954665,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                },
            },
            --["groupId"] = 35, --change
            ["hidden"] = false,
            ["units"] = 
            {
                [1] = 
                {
                    ["alt"] = 2000,
                    ["hardpoint_racks"] = true,
                    ["alt_type"] = "BARO",
                    ["livery_id"] = "19th Fighter SQN (AK)",
                    ["skill"] = "Excellent",
                    ["speed"] = 138.88888888889,
                    ["type"] = "F-15C",
                    --["unitId"] = 35, --change
                    ["psi"] = -1.6535264395135,
                    ["y"] = 810485.71428571, --change
                    ["x"] = -287874.2857143, --change
                    ["name"] = "Pilot #027", --change
                    ["payload"] = 
                    {
                        ["pylons"] = 
                        {
                            [1] = 
                            {
                                ["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
                            },
                            [3] = 
                            {
                                ["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
                            },
                            [9] = 
                            {
                                ["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
                            },
                            [11] = 
                            {
                                ["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
                            },
                        },
                        ["fuel"] = 4882,
                        ["flare"] = 60,
                        ["chaff"] = 120,
                        ["gun"] = 100,
                    },
                    ["heading"] = 1.6535264395135,
                    --["callsign"] = 
                    --{
                     --   [1] = 1,
                      --  [2] = 2,
                       -- [3] = 1,
                       -- ["name"] = "Enfield21",
                    --},
                    --["onboard_num"] = "055",
                },
            },
            ["y"] = 810485.71428571, --change
            ["x"] = -287874.2857143, --change
            ["name"] = "blue_ai_cap_1", --change
            --["communication"] = true,
            --["start_time"] = 0,
            --["modulation"] = 0,
            --["frequency"] = 124,
        }
        return air_group_template
    end
    
    
    local function getRedAirCAPGroupTemplate()
        local air_group_template={
            ["lateActivation"] = false,
            ["tasks"] = 
            {
            },
            ["radioSet"] = false,
            ["task"] = "CAP",
            ["uncontrolled"] = false,
            ["route"] = 
            {
                ["routeRelativeTOT"] = true,
                ["points"] = 
                {
                    [1] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        }, -- end of ["properties"]
                        ["ETA"] = 0,
                        ["y"] = 921542.85714285, --change
                        ["x"] = -282817.14285715, --change
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                    [1] = 
                                    {
                                        ["number"] = 1,
                                        ["key"] = "CAP",
                                        ["id"] = "EngageTargets",
                                        ["enabled"] = true,
                                        ["auto"] = true,
                                        ["params"] = 
                                        {
                                            ["targetTypes"] = 
                                            {
                                                [1] = "Air",
                                            },
                                            ["priority"] = 0,
                                        },
                                    },
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [2] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 401.6592222518,
                        ["y"] = 866607.14285714,
                        ["x"] = -292520.00000001,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [3] = 
                    {
                        ["alt"] = 2000,
                        ["type"] = "Turning Point",
                        ["action"] = "Turning Point",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 1115.7772810985,
                        ["y"] = 851407.14285713,
                        ["x"] = -194508.57142858,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                    [4] = 
                    {
                        ["alt"] = 540,
                        ["type"] = "Land",
                        ["action"] = "Landing",
                        ["alt_type"] = "BARO",
                        ["formation_template"] = "",
                        ["properties"] = 
                        {
                            ["vnav"] = 1,
                            ["scale"] = 0,
                            ["angle"] = 0,
                            ["vangle"] = 0,
                            ["steer"] = 2,
                        },
                        ["ETA"] = 1449.3798037593,
                        ["airdromeId"] = 32,
                        ["y"] = 843756.7533062,
                        ["x"] = -148810.84954665,
                        ["speed"] = 138.88888888889,
                        ["ETA_locked"] = false,
                        ["task"] = 
                        {
                            ["id"] = "ComboTask",
                            ["params"] = 
                            {
                                ["tasks"] = 
                                {
                                },
                            },
                        },
                        ["speed_locked"] = true,
                    },
                },
            },
            --["groupId"] = 36,
            ["hidden"] = false,
            ["units"] = 
            {
                [1] = 
                {
                    ["alt"] = 2000,
                    ["hardpoint_racks"] = true,
                    ["alt_type"] = "BARO",
                    ["livery_id"] = "Air Force Standard",
                    ["skill"] = "Excellent",
                    ["speed"] = 138.88888888889,
                    ["type"] = "Su-27",
                    --["unitId"] = 36,
                    ["psi"] = 1.745615385889,
                    ["y"] = 921542.85714285, --change
                    ["x"] = -282817.14285715, --change
                    ["name"] = "Pilot #028", --change
                    ["payload"] = 
                    {
                        ["pylons"] = 
                        {
                            [1] = 
                            {
                                ["CLSID"] = "{44EE8698-89F9-48EE-AF36-5FD31896A82F}",
                            },
                            [2] = 
                            {
                                ["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
                            },
                            [3] = 
                            {
                                ["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
                            },
                            [8] = 
                            {
                                ["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
                            },
                            [10] = 
                            {
                                ["CLSID"] = "{44EE8698-89F9-48EE-AF36-5FD31896A82A}",
                            },
                            [9] = 
                            {
                                ["CLSID"] = "{FBC29BFE-3D24-4C64-B81D-941239D12249}",
                            },
                        },
                        ["fuel"] = 4888,
                        ["flare"] = 96,
                        ["chaff"] = 96,
                        ["gun"] = 100,
                    },
                    ["heading"] = -1.745615385889,
                    --["callsign"] = 113,
                    --["onboard_num"] = "055",
                },
            },
            ["y"] = 921542.85714285, --change
            ["x"] = -282817.14285715, --change
            ["name"] = "red_ai_cap_1", --change
            --["communication"] = true,
            --["start_time"] = 0,
            --["modulation"] = 0,
            --["frequency"] = 127.5,
        }
        return air_group_template
    end
    
    local function spawnAirCAPGroups()
        --env.info('spawnAirCAPGroup start')
        local airgroup=getBlueAirCAPGroupTemplate()
        local baseid=(math.floor(timer.getTime())+39)*20
        subid=math.random(table.getn(blue_capunit_pos))
        airgroup.route.points[1].y=blue_capunit_pos[subid].y
        airgroup.route.points[1].x=blue_capunit_pos[subid].x
        airgroup.units[1].x=blue_capunit_pos[subid].x
        airgroup.units[1].y=blue_capunit_pos[subid].y
        airgroup.x=blue_capunit_pos[subid].x
        airgroup.y=blue_capunit_pos[subid].y
        airgroup.units[1].name=string.format("blue_ai_cap_unit_%d",baseid)
        airgroup.name=string.format("blue_ai_cap_%d",baseid)
        coalition.addGroup(country.id.USA, Group.Category.AIRPLANE, airgroup)
        airgroup=getRedAirCAPGroupTemplate()
        baseid=baseid+1
        subid=math.random(table.getn(red_capunit_pos))
        airgroup.route.points[1].y=red_capunit_pos[subid].y
        airgroup.route.points[1].x=red_capunit_pos[subid].x
        airgroup.units[1].x=red_capunit_pos[subid].x
        airgroup.units[1].y=red_capunit_pos[subid].y
        airgroup.x=red_capunit_pos[subid].x
        airgroup.y=red_capunit_pos[subid].y
        airgroup.units[1].name=string.format("red_ai_cap_unit_%d",baseid)
        airgroup.name=string.format("red_ai_cap_%d",baseid)
        coalition.addGroup(country.id.RUSSIA, Group.Category.AIRPLANE, airgroup)
        --env.info('spawnAirCAPGroup finish')
        return timer.getTime() + trigger.misc.getUserFlag(13)*60+10
	end
    
    local function unitDetectedInEgressZone(unit)
        if (not unit:getPlayerName()) and unit:getDesc().category==Unit.Category.AIRPLANE then
            unit:getGroup():destroy()
        end
        return true
    end
    
    local airzoneradius=6500
    local airEgress1={
        ["id"]=world.VolumeType.BOX,
        ["params"]={
            ["min"]={
                ["x"]=airunit_wps[2].x-airzoneradius,
                ["y"]=airunit_wps[2].alt-100000,
                ["z"]=airunit_wps[2].y-airzoneradius
            },
            ["max"]={
                ["x"]=airunit_wps[2].x+airzoneradius,
                ["y"]=airunit_wps[2].alt+100000,
                ["z"]=airunit_wps[2].y+airzoneradius
            }
        }
    }
    local airEgress2={
        ["id"]=world.VolumeType.BOX,
        ["params"]={
            ["min"]={
                ["x"]=-317557.14285714-airzoneradius,
                ["y"]=2000-100000,
                ["z"]=899071.42857143-airzoneradius
            },
            ["max"]={
                ["x"]=-317557.14285714+airzoneradius,
                ["y"]=2000+100000,
                ["z"]=899071.42857143+airzoneradius
            }
            --["y"] = 899071.42857143, 4.1nm
            --["x"] = -317557.14285714,
        }
    }
    local function checkEgressAirGroups()
        world.searchObjects(Object.Category.UNIT,airEgress1,unitDetectedInEgressZone)
        world.searchObjects(Object.Category.UNIT,airEgress2,unitDetectedInEgressZone)
        return timer.getTime() + 6
    end
    
	--env.info("spawn script start")
	timer.scheduleFunction(spawnGroups, nil, timer.getTime() + 1)
    timer.scheduleFunction(spawnAAGroups, nil, timer.getTime() + 2)
    timer.scheduleFunction(checkReachedGroups, nil, timer.getTime() + 3)
    timer.scheduleFunction(checkEgressAirGroups, nil, timer.getTime() + 4)
    timer.scheduleFunction(spawnAirCASGroups, nil, timer.getTime() + trigger.misc.getUserFlag(12)*60+20)
    timer.scheduleFunction(spawnAirCAPGroups, nil, timer.getTime() + trigger.misc.getUserFlag(13)*60+10)
    trigger.action.outText(string.format("Mission started. Score: Blue: %d Red: %d\nArmor spawn interval: 3 mins\nAAA spawn interval: %d mins\nAI CAS spawn interval: %d mins\nAI CAP spawn interval: %d mins",trigger.misc.getUserFlag(1),trigger.misc.getUserFlag(2),trigger.misc.getUserFlag(11),trigger.misc.getUserFlag(12),trigger.misc.getUserFlag(13)),10)
	--env.info("spawn script finish")
end
